/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 16.09.2009
Author  : 
Company : 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm
#include <lcd.h>
#include <stdio.h>
#define menu PINB.2
#define enter PINB.3
#define plus PINB.4
#define minus PINB.5
#define sw1 PINC.5
#define sw2 PINC.4
#define ADC_VREF_TYPE 0x40


char lcd_buffer[33];
int  pauseind, taho1, taho2, taho3, taho4, taho5, taho6, taho7, taho8, taho9, taho10,taho11, taho, pwm, zadanie[40], ust_cnt_pwm;
unsigned char   truba, ind,  rejim, menu_pres,plus_pres, plus_press, minus_pres, minus_press,pz_btn, cnt_pwm;
eeprom int zadanie_mem[40]; 
eeprom unsigned char ust_cnt_pwm_mem=10, truba_mem=1;

void vichisl (void)
{
if(rejim!=3)
{
if(taho<zadanie[truba])
 {
 if(taho+50<zadanie[truba] && pwm<1000)pwm=pwm+5;
 else
 {
 if(pwm<1000) pwm++;
 }
 }
if(taho>zadanie[truba])
 {
 if(taho>zadanie[truba]+50 && pwm>5)pwm=pwm-5;
 else
 {
 if(pwm>0) pwm--;
 }
 }
} 
if(sw1==0)pwm=0;
OCR1AH=pwm>>8;
OCR1AL=pwm;

}
// Timer 0 overflow interrupt service routine  61   (0.0164) 
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
if(ind!=0)pauseind++;
if(pauseind==1000)
{
rejim=0;
ind=0;
pauseind=0;
}

cnt_pwm++;
if(cnt_pwm==ust_cnt_pwm)
  {
  cnt_pwm=0;
  vichisl();
  }
if( (plus_pres && minus_pres)==0)pz_btn++;
else pz_btn=0;  
}

// Timer 2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}



// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
// Read the AD conversion result
taho11=taho10;
taho10=taho9;
taho9=taho8;
taho8=taho7;
taho7=taho6;
taho6=taho5;
taho5=taho4;
taho4=taho3; 
taho3=taho2;
taho2=taho1;
taho1=ADCW;
taho=(taho1+taho2+taho3+taho4+taho5+taho6+taho7+taho8+taho9+taho10+taho11)/11;
// Place your code here
ADCSRA|=0x40;
}



void indikator (void)
{
switch (rejim)
    {
    case 0:lcd_gotoxy(0,1); if(sw1==0) lcd_putsf("ǽyee ocao "); else lcd_putsf("ǽyee             ");
           lcd_gotoxy(0,0); sprintf(lcd_buffer,"taho=%u ,M=%u        ", taho ,pwm); break; 
    case 1:lcd_gotoxy(0,0); lcd_putsf("òop py     "); lcd_gotoxy(0,1);
         switch(truba)
        {
        case 1: lcd_putsf("D20 PE32 6AT    "); break;
        case 2: lcd_putsf("D20 PE32 10AT   "); break;
        case 3: lcd_putsf("D20 PE63 10AT   "); break;
        case 4: lcd_putsf("D20 PE80 12,5AT "); break;
        case 5: lcd_putsf("D20 PE80 16AT   "); break;
        case 6: lcd_putsf("D25 PE32 4AT    "); break;
        case 7: lcd_putsf("D25 PE32 6AT    "); break;
        case 8: lcd_putsf("D25 PE32 10AT   "); break;
        case 9: lcd_putsf("D25 PE63 6AT    "); break;
        case 10: lcd_putsf("D25 PE63 10AT   "); break;
        case 11: lcd_putsf("D25 PE80 10AT   "); break;
        case 12: lcd_putsf("D25 PE80 12,5AT "); break;
        case 13: lcd_putsf("D25 PE80 16AT   "); break;
        case 14: lcd_putsf("D32 PE32 4AT    "); break;
        case 15: lcd_putsf("D32 PE32 6AT    "); break;
        case 16: lcd_putsf("D32 PE32 10AT   "); break;
        case 17: lcd_putsf("D32 PE63 6AT    "); break;
        case 18: lcd_putsf("D32 PE63 10AT   "); break;
        case 19: lcd_putsf("D32 PE80 8AT    "); break;
        case 20: lcd_putsf("D32 PE80 10AT   "); break;
        case 21: lcd_putsf("D32 PE80 12,5AT "); break;
        case 22: lcd_putsf("D32 PE80 16AT   "); break;
        case 23: lcd_putsf("D40 PE32 4AT    "); break;
        case 24: lcd_putsf("D40 PE32 6AT    "); break;
        case 25: lcd_putsf("D40 PE32 10AT   "); break;
        case 26: lcd_putsf("D40 PE63 6AT    "); break;
        case 27: lcd_putsf("D40 PE63 10AT   "); break;
        case 28: lcd_putsf("D40 PE80 8AT    "); break;
        case 29: lcd_putsf("D40 PE80 10AT   "); break;
        case 30: lcd_putsf("D40 PE80 12,5AT "); break;
        case 31: lcd_putsf("D40 PE80 16AT   "); break;
        case 32: lcd_putsf("D50 PE32 4AT    "); break;
        case 33: lcd_putsf("D50 PE32 6AT    "); break;
        case 34: lcd_putsf("D50 PE32 10AT   "); break;
        case 35: lcd_putsf("D50 PE63 6AT    "); break;
        case 36: lcd_putsf("D50 PE63 10AT   "); break;
        case 37: lcd_putsf("D50 PE80 8AT    "); break;
        case 38: lcd_putsf("D50 PE80 10AT   "); break;
        case 39: lcd_putsf("D50 PE80 12,5AT "); break;
        case 40: lcd_putsf("D50 PE80 16AT   "); break;
        };
        break;
    case 2:lcd_gotoxy(0,0);lcd_putsf("aae copc "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"aae=%u       ",zadanie[truba]);break;
    case 3:lcd_gotoxy(0,0);lcd_putsf("copc eocp  "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"pwm=%u           ",pwm);break;
    case 4:lcd_gotoxy(0,0);lcd_putsf("e㸿e pea "); lcd_gotoxy(0,1); sprintf(lcd_buffer,"t=%u             ",ust_cnt_pwm);break;
    }; 
lcd_puts(lcd_buffer);

}



void knopki(void)
{

if((menu && enter && plus && minus)==0)
{
pauseind=0;
ind=1;
}
if(menu==0)
 {
 if(menu_pres==1)
  {
  rejim++;
  if(rejim==5)rejim=0;
  menu_pres=0;
  }
 }
else menu_pres=1;  


if (rejim==1)// 
  {
       if(plus==0)
     {
     if(plus_pres==1)
      {
      truba++;
      if(truba==41)truba=1;
      plus_pres=0;
      }
     }
    else plus_pres=1;
    
    if(minus==0)
     {
     if(minus_pres==1)
      {
      truba--;
      if(truba==0)truba=40;
      minus_pres=0;
      }
     }
    else minus_pres=1;
  } 
if(truba!=truba_mem)truba_mem=truba; 




if (rejim==2)//  
  {
  if(plus==0 && zadanie[truba]<1000)
   {
   if(plus_pres==1)
    {
    plus_pres=0;
    zadanie[truba]++;
    }
   else if(pz_btn>60)
    {
    plus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && plus_press==1)
    {
    zadanie[truba]++;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   plus_pres=1;
   plus_press=0;
   }   
     
     
     
    if(minus==0 && zadanie[truba]>1)
   {
   if(minus_pres==1)
    {
    minus_pres=0;
    zadanie[truba]--;
    }
   else if(pz_btn>60)
    {
    minus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && minus_press==1)
    {
    zadanie[truba]--;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   minus_pres=1;
   minus_press=0;
   }   
  } 
if(zadanie_mem[truba]!=zadanie[truba]) zadanie_mem[truba]=zadanie[truba];  
  
  if (rejim==3) //  
  {
  if(plus==0 && pwm<725)
   {
   if(plus_pres==1)
    {
    plus_pres=0;
    pwm++;
    }
   else if(pz_btn>60)
    {
    plus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && plus_press==1)
    {
    pwm++;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   plus_pres=1;
   plus_press=0;
   }   
     
     
     
    if(minus==0 && pwm>1)
   {
   if(minus_pres==1)
    {
    minus_pres=0;
    pwm--;
    }
   else if(pz_btn>60)
    {
    minus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && minus_press==1)
    {
    pwm--;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   minus_pres=1;
   minus_press=0;
   }   
  }
  
  
   if (rejim==4) //  
  {
  if(plus==0 && ust_cnt_pwm<100)
   {
   if(plus_pres==1)
    {
    plus_pres=0;
    ust_cnt_pwm++;
    }
   else if(pz_btn>60)
    {
    plus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && plus_press==1)
    {
    ust_cnt_pwm++;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   plus_pres=1;
   plus_press=0;
   }   
     
     
     
    if(minus==0 && ust_cnt_pwm>1) 
   {
   if(minus_pres==1)
    {
    minus_pres=0;
    ust_cnt_pwm--;
    }
   else if(pz_btn>60)
    {
    minus_press=1;
    pz_btn=0;
    }
    if(pz_btn>10 && minus_press==1)
    {
    ust_cnt_pwm--;
    pz_btn=0;
    }
    
      
   }
   else 
   {
   minus_pres=1;
   minus_press=0;
   }   
  }
  if(ust_cnt_pwm_mem!=ust_cnt_pwm)ust_cnt_pwm_mem=ust_cnt_pwm;                      
}


// Declare your global variables here

void main(void)
{


    
    

 

// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=P State5=P State4=P State3=P State2=P State1=0 State0=T 
PORTB=0x7C;
DDRB=0x02;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=P State4=P State3=T State2=T State1=T State0=T 
PORTC=0x30;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x03;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 4000,000 kHz
// Mode: Fast PWM top=03FFh
// OC1A output: Inverted
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xC3;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x04;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x41;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 31,250 kHz
// ADC Voltage Reference: AVCC pin
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x8F;

// LCD module initialization
lcd_init(16);

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/2048k
#pragma optsize-
WDTCR=0x1F;
WDTCR=0x0F;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif 

// Global enable interrupts
#asm("sei")
ADCSRA|=0x40;

    for(truba=1;truba<40;truba++)
    {
    zadanie[truba]=zadanie_mem[truba];
    }  
truba=truba_mem;
ust_cnt_pwm=ust_cnt_pwm_mem;

while (1)
      {
      // Place your code here
      #asm("wdr")
      knopki();
      indikator();
      
      };
}
